/**
*Netdrive App
* Implementing Netdrive App
*/
var NetdriveApp = NetdriveApp || {};  //Define Netdrive App namespace.
/**
*Constructor UNAS App
*/
NetdriveApp.App = function () {
	this.id = 'Netdrive';
	this.name = 'Netdrive';
	this.version = '6.0.20';
	this.active = false;
	this.menuIcon = '/apps/netdrive/images/logo.png?v=6.0.20&';
	this.shortcutIcon = '/apps/netdrive/images/logo.png?v=6.0.20&';
	this.entryUrl = '/apps/netdrive/netdrive.html?v=6.0.20&';
	//this.entryHelpUrl = '/apps/netdrive/netdrive_help.html?v=6.0.20&';
	var self = this;
	this.NetdriveAppWindow = function () {
		if(UNAS.CheckAppState('Netdrive')){
			return false;
		}
		self.window=new MUI.Window({
			id: 'NetdriveAppWindow',
			title: UNAS._('Netdrive'),
			icon: '/apps/netdrive/images/logo_small.png?v=6.0.20&',
			loadMethod: 'xhr',
			width: 800,
			height: 450,
			maximizable: false,
			resizable: true,
			scrollbars: false,
			resizeLimit: { 'x': [800, 1200], 'y': [450, 900] },
			contentURL: '/apps/netdrive/netdrive.html?v=6.0.20&',
			require: {  css: ['/apps/netdrive/css/netdrive.css'] },
			onBeforeBuild: function(){
				UNAS.SetAppOpenedWindow('Netdrive','NetdriveAppWindow');
			},
			onClose:function(){
				if(window.netdrive && window.netdrive.onClose){
					window.netdrive.onClose();
					window.netdrive.onClose = null;
				}
				window.netdrive = null;
			}
	 	});
	};
	this.NetdriveUninstall = function (){
		UNAS.RemoveDesktopShortcut('Netdrive');
		UNAS.RemoveMenu('Netdrive');
		UNAS.RemoveAppFromGroups('Netdrive', 'Help');
		UNAS.RemoveAppFromGroups('Netdrive', 'ControlPanel');
		UNAS.RemoveAppFromApps('Netdrive');
	};
	new UNAS.Menu("UNAS_ControlPanel_Storage_Menu", this.name, this.menuIcon, 'Netdrive', '', this.NetdriveAppWindow);
	//new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {'Type' : 'Other', 'Location' : 3, "Icon": this.shortcutIcon, "Url": this.contentURL},{});
	//new UNAS.RegisterToAppGroup(this.name, 'Help', {'Type' : 'Other', 'Location' : 3, "Icon": this.shortcutIcon, "Url": this.entryHelpUrl},{});
	//new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'Volumes Manager', this.lvmAppWindow);
    new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {'Type' : 'Storage', 'Location' : 3, "Icon": this.shortcutIcon, "Url": this.entryUrl},{});

	var OnChangeLanguage = function (e) {
		UNAS.SetMenuTitle('Netdrive', UNAS._('Netdrive')); //translate menu
		UNAS.SetShortcutTitle('Netdrive', UNAS._('Netdrive'));
		if (typeof self.window !== 'undefined') {
			UNAS.SetWindowTitle('NetdriveAppWindow', UNAS._('Netdrive'));
		}
	};
	UNAS.LoadTranslation('/apps/netdrive/languages/Translation?v='+this.version, OnChangeLanguage);
	UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
	UNAS.CreateApp(this.name, this.shortcutIcon, this.NetdriveAppWindow, this.NetdriveUninstall);
};

new NetdriveApp.App();
