var protocolPrefix = /^(?:http:\/\/|https:\/\/)?/;

function isValidIPv6(address) {
    const ipv6Regex = new RegExp(protocolPrefix.source + /\[((?:[A-Fa-f0-9]{1,4}:)*[A-Fa-f0-9]*::?(?:[A-Fa-f0-9]{1,4}:)*[A-Fa-f0-9]*?)\](?::([0-9]{1,5}))?/.source);
    return ipv6Regex.test(address);
}

function isValidIPv4(address) {
    const ipv4Regex = new RegExp(protocolPrefix.source + /(?:(?:25[0-4]|2[0-4][0-9]|1[0-9]{2}|[1-9]?[0-9])\.){3}(?:25[0-4]|2[0-4][0-9]|1[0-9]{2}|[1-9]?[0-9])(?::([0-9]{1,5}))?/.source);
    return ipv4Regex.test(address);
}

function isValidDomain(address) {
    const domainRegex = new RegExp(protocolPrefix.source + /(?:[a-zA-Z0-9\-]+\.)+[a-zA-Z]{2,}(?::([0-9]{1,5}))?/.source);
    return domainRegex.test(address);
}
