var cwh = getClientWH();
window.netdrive = {};

window.netdrive.onClose = function() {
  //console.log('>>>>>>onClose netdrive');
  window.netdrive.showWindowNotice = null;

  //停止轮询请求
  stopTickRefresh();

  window.netdrive.currentTaskData = null;
  window.netdrive.currentStorageData = null;
  window.netdrive.currentName = null;


  window.netdrive.storagesOriginal = null;
  window.netdrive.tasksOriginal = null;
};

var REFRESH_INTERVAL = 5000;
var REFRESH_TIMEOUT = 200;
var _isWaiting = false;
var _interval = null;
var _needScrollToTop = false;

var _storagesOriginal = []; //保存获取到的原始存储源列表数据
var _storages = []; //用于显示的存储源列表数据
var _currentStorageIndex = -1; //当前操作元素（表格行）对应的索引号


var _currentStorageDatas = [];

jQuery("#netdrive_manager_vg_list").mCustomScrollbar({
  autoHideScrollbar: true,
  theme: "minimal-dark"
});

//开始轮询请求
function startTickRefresh() {
  stopTickRefresh();
  _interval = setInterval(function() {
    refreshData();
  }, REFRESH_INTERVAL);
}
//停止轮询请求
function stopTickRefresh() {
  if (_interval) {
    clearInterval(_interval);
  }
}

//等待REFRESH_TIMEOUT后刷新列表
function timeoutRefreshData() {
  stopTickRefresh();
  setTimeout(function() {
    //console.log('>>>>>>timeoutRefreshData');
    getVGsInfo(false);
    // hideWaiting()
  }, REFRESH_TIMEOUT);
}

function refreshData() {
  stopTickRefresh();
  getVGsInfo(false);
}

function hideWaiting() {
  jQuery('#netdrive_manager_waiting_content').hide()
  jQuery('#netdrive_manager_waiting_logo').hide()
}

// 格式化size
function formSize(bytes, decimalPoint) {
  var num = bytes;
  if (typeof(num) !== "number") {
    num = parseInt(num)
  }
  if (num <= 0) return '0 Bytes';
  var k = 1024,
    dm = decimalPoint || 2,
    sizes = ['KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB', 'BB'],
    i = Math.floor(Math.log(num) / Math.log(k));
  return parseFloat((num / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
}

function mountLv(vg, lv, crypt) {
  var m_id = "mountlv" + vg + "-" + lv;
  var b_id = "percentagebox" + vg + "-" + lv;
  var bimg_id = "percentageimg" + vg + "-" + lv;
  var d_id = "deletelv" + vg + "-" + lv;
  var selfclass = jQuery("#" + m_id).attr("class");
  if (selfclass == "umount") {
    var UmountLvW = new MUI.Modal({
      id: 'UmountLvWindow',
      title: UNAS._('##$@netdrive@$##Umount Volume##$@netdrive@$##'),
      modal: true,
      modalOverlayClose: false,
      width: 400,
      height: 220,
      contentURL: '/apps/netdrive/umount_lv.html?v=6.0.20&vgname=' + vg + '&lvname=' + lv + '&crypt=' + crypt
    });
    UmountLvW.ProcessUmountLv = function() {
      getVGsInfo(vg);
    }
  }
  if (selfclass == "mount") {
    var MountLvW = new MUI.Modal({
      id: 'MountLvWindow',
      title: UNAS._('##$@netdrive@$##Mount Volume##$@netdrive@$##'),
      modal: true,
      modalOverlayClose: false,
      width: 400,
      height: 220,
      contentURL: '/apps/netdrive/mount_lv.html?v=6.0.20&vgname=' + vg + '&lvname=' + lv + '&crypt=' + crypt
    });
    MountLvW.ProcessMountLv = function() {
      getVGsInfo(vg);
    }
  }
}

function deleteLv(vg, lv, crypt) {
  var d_id = "deletelv" + vg + "-" + lv;
  if (jQuery("#" + d_id).attr("class") != "lv_delete_none") {
    var lvtype = jQuery("#" + d_id).attr("type");
    var DeleteLvW = new MUI.Modal({
      id: 'DeleteLvWindow',
      title: UNAS._('##$@netdrive@$##Delete Volume##$@netdrive@$##'),
      modal: true,
      width: 400,
      height: 220,
      modalOverlayClose: false,
      contentURL: '/apps/netdrive/delete_lv.html?v=6.0.20&vgname=' + vg + '&lvname=' + lv + '&lvtype=' + lvtype + '&crypt=' + crypt
    });
    DeleteLvW.ProcessDeleteLv = function() {
      getVGsInfo(vg);
    }
  }
}

function CreateNetdriveWindowFun() {
  var _netdriveWindow = new MUI.Modal({
    id: 'netdriveWindowAddStorage',
    title: UNAS._('##$@netdrive@$##Create Net Drive##$@netdrive@$##'),
    contentURL: '/apps/netdrive/m/netdrive_create.html?v=6.0.20&',
    modal: true,
    modalOverlayClose: false,
    width: cwh.w,
    height: parseInt(cwh.h * 0.72),
    addClass: 'mobile-modal',
    onClose: function() {
      if (window.netdrive.onCloseAddStorage) {
        window.netdrive.onCloseAddStorage();
        window.netdrive.onCloseAddStorage = null;
      }
      startTickRefresh();
    }
  });
  _netdriveWindow.callback = function() {
    //新增数据后，先清空筛选文本
    // jQuery('#netdrive_storage_btn_search').val('');
    timeoutRefreshData();
  }
  // _netdriveWindow.ProcessCreateVg = function(){
  // 	getVGsInfo("");
  // }
  // jQuery(_netdriveWindow.windowEl).addClass('modal-t-2');
}

//去除中括号两边多余的双引号
function removeExtraQuotationMarks(jsonstr) {
  var str = jsonstr.replace(/\"\[/g, '['); //g代表全部替换，没有g，只替换第一个，
  str = str.replace(/\]\"/g, ']');
  str = str.replace(/\\/g, '');
  return str;
}

// 编辑
EditNetdriveWindowFun = function(e, name) {

  window.netdrive.currentStorageData = _storagesOriginal.filter(item => item.name == name)[0]
  // console.log(window.netdrive.currentStorageData);
  // window.usync.currentStorageData = _storagesOriginal[_currentStorageIndex]; //设置当前编辑任务的关联数据


  stopTickRefresh();

  var _editNetdrive = new MUI.Modal({
    id: 'editNetdriveWindow',
    title: UNAS._('##$@netdrive@$##Edit Net Drive##$@netdrive@$##'),
    modal: true,
    width: cwh.w,
    height: parseInt(cwh.h * 0.72),
    addClass: 'mobile-modal',
    modalOverlayClose: false,
    contentURL: '/apps/netdrive/m/netdrive_edit.html?v=6.0.20&',
    onClose: function() {
      if (window.netdrive.onCloseEditStorage) {
        window.netdrive.onCloseEditStorage();
        window.netdrive.onCloseEditStorage = null;
      }
      startTickRefresh();
    }
  });
  _editNetdrive.ProcessEditNetdrive = function() {
    refreshData();
  }
  // EditNetdriveW.ProcessEditNetdrive = function(){
  // 	getVGsInfo(type);
  // }
}

// 删除
DeleteNetdriveWindowFun = function(type, name) {
  stopTickRefresh();
  window.netdrive.currentName = name;
  var _netdriveWindow = new MUI.Modal({
    id: 'netdriveWindowDelete',
    title: UNAS._('##$@netdrive@$##Delete Volume##$@netdrive@$##'),
    contentURL: '/apps/netdrive/m/netdrive_delete.html?v=6.0.20&',
    modal: true,
    modalOverlayClose: false,
    width: parseInt(cwh.w * 0.9),
    addClass: 'delete-modal',
    height: 220,
    onClose: function() {
      if (window.netdrive.onCloseDeleteStorage) {
        window.netdrive.onCloseDeleteStorage();
        window.netdrive.onCloseDeleteStorage = null;
      }
      startTickRefresh();
    }
  });
  _netdriveWindow.callBack = function() {
    // 参考 doDeleteStorage()
    // refreshData()
    // doMountVolume(name)
    doDeleteVolume(type, name)
  };
}

// 挂载
MountNetdriveWindowFun = function(name) {
  stopTickRefresh();
  window.netdrive.currentName = name;
  // jQuery('#netdrive_name').text(_currentStorageDatas)

  var _netdriveWindow = new MUI.Modal({
    id: 'netdriveWindowMount',
    title: UNAS._('##$@netdrive@$##Mount Volume##$@netdrive@$##'),
    contentURL: '/apps/netdrive/m/netdrive_mount.html?v=6.0.20&',
    modal: true,
    modalOverlayClose: false,
    width: parseInt(cwh.w * 0.9),
    addClass: 'delete-modal',
    height: 220,
    onClose: function() {
      if (window.netdrive.onCloseMountStorage) {
        window.netdrive.onCloseMountStorage();
        window.netdrive.onCloseMountStorage = null;
      }
      startTickRefresh();
    }
  });
  _netdriveWindow.callBack = function() {
    // 参考 doDeleteStorage()
    // refreshData()
    doMountVolume(name)
  };
}

// 卸载
UnMountNetdriveWindowFun = function(name) {
  stopTickRefresh();
  window.netdrive.currentName = name;

  // jQuery('#netdrive_name').text(_currentStorageDatas)

  var _netdriveWindow = new MUI.Modal({
    id: 'netdriveWindowUnMount',
    title: UNAS._('##$@netdrive@$##Unmount Volume##$@netdrive@$##'),
    contentURL: '/apps/netdrive/netdrive_unmount.html?v=6.0.20&',
    modal: true,
    modalOverlayClose: false,
    width: parseInt(cwh.w * 0.9),
    addClass: 'delete-modal',
    height: 220,
    onClose: function() {
      if (window.netdrive.onCloseUnMountStorage) {
        window.netdrive.onCloseUnMountStorage();
        window.netdrive.onCloseUnMountStorage = null;
      }
      startTickRefresh();
    }
  });
  _netdriveWindow.callBack = function() {
    // 参考 doDeleteStorage()
    // refreshData()
    doUnMountVolume(name)
  };
}

// 点击显示隐藏
openCloseNetdriveWindow = function(e, i) {
  // console.log(e,i);
  // alert(1)
  var class_name = jQuery(e).attr("class");
  if (class_name == "close_img") {
    jQuery("#netdrive_" + i).attr("class", "netdrive_close");
    jQuery(e).attr("class", "open_img");
    jQuery("#netdrive_dd" + i).attr("style", "display:none");
  } else {
    jQuery("#netdrive_" + i).attr("class", "netdrive_open");
    jQuery(e).attr("class", "close_img");
    jQuery("#netdrive_dd" + i).attr("style", "display:block");
  }
}

function getVGsInfo(sel_vg) {
  // jQuery('#netdrive_manager_waiting_content').attr("style", "display: block");
  // jQuery('#netdrive_manager_waiting_logo').attr("style", "display: block");
  data = {
    cmd: "netdrive_get_status",
    token: UToken
  }
  jQuery.ajax({
    url: "/apps/netdrive/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.stringify(data),
    timeout: 30000,
    dataType: "json",
    success: function(data) {
      data = data.results.storage;
      // console.log(data.SAMBA[1].host);
      jQuery('#netdrive_manager_page_createvg').html('##$@netdrive@$##Create Net Drive##$@netdrive@$##');
      jQuery('#netdrive_list').html('');

      _storagesOriginal = combineStorage(data); //保存获取到的原始存储源列表数据
      // window.usync.storageTypes = data.results.storage.types;
      window.netdrive.storagesOriginal = _storagesOriginal;
      // console.log(_storagesOriginal);

      var is_open = true;
      var netdrive_raw = true;
      var isMounted = false;

      // 显示顺序 SAMBA FTP
      var _current_netdrive_arr = data.types.unshift(...data.types.splice(data.types.findIndex(i => i == 'FTP'), 1))
      _current_netdrive_arr = data.types.unshift(...data.types.splice(data.types.findIndex(i => i == 'SAMBA'), 1))

      for (const type of data.types) {
        // console.log(type);
        if (data[type].length) {
          var netdrive_top = '<dt class="' + ((is_open) ? "netdrive_open" : "netdrive_close") + '" id="netdrive_' + type + '">' +
            '<div class="open_button">' +
            '<a><span class="' + ((is_open) ? "close_img" : "open_img") + '" onclick="openCloseNetdriveWindow(this,\'' + type + '\');"></span></a>' +
            // '<a><span class="'+((is_open)?"close_img":"open_img")+'" onclick="openCloseNetdriveWindow(this);"></span></a>'+
            '</div>' +
            '<div class="title"> <span class="title_img_' + type + '"></span>	 <span>##$@netdrive@$##' + type + '##$@netdrive@$##</span></div>' +
            '</dt>';
          netdrive_raw = false;
          var storage_html = "";
          for (var i = 0; i < data[type].length; i++) {
            storage = data[type][i];
            // console.log(storage.ID);
            storage_head = '<h3><a title="' + storage.name + '"> ' + trunc(storage.name, 20) + '</a></h3>';
            if (storage.mounted) {
              var _storage_act = '<div class="volume_action"><p>' +
                // '<a id="netdriveEdit" ref-data-id='+storage.ID+' title="##$@netdrive@$##View and Edit Volume Property##$@netdrive@$##" >##$@netdrive@$##Property##$@netdrive@$##</a>' +
                '<a ref-data-id=' + storage.ID + ' onclick="EditNetdriveWindowFun(this,\'' + storage.name + '\')" title="##$@netdrive@$##View and Edit Volume Property##$@netdrive@$##" >##$@netdrive@$##Property##$@netdrive@$##</a>' +
                '<a onclick="UnMountNetdriveWindowFun(\'' + storage.name + '\')" >##$@netdrive@$##Unmount##$@netdrive@$##</a>' +
                '<a class="NetdriveMounted" >##$@netdrive@$##Mounted##$@netdrive@$##</a>' +
                '</p></div>';
            } else if (storage.mount_failure) {
              var _storage_act = '<div class="volume_action"><p>' +
                // '<a id="netdriveEdit" ref-data-id='+storage.ID+'  title="##$@netdrive@$##View and Edit Volume Property##$@netdrive@$##" >##$@netdrive@$##Property##$@netdrive@$##</a>' +
                '<a ref-data-id=' + storage.ID + ' onclick="EditNetdriveWindowFun(this,\'' + storage.name + '\')" title="##$@netdrive@$##View and Edit Volume Property##$@netdrive@$##" >##$@netdrive@$##Property##$@netdrive@$##</a>' +
                '<a class="NetdriveMountedFailure" onclick="MountNetdriveWindowFun(\'' + storage.name +
                '\')" title="##$@netdrive@$##Please check your network and configuration##$@netdrive@$##">##$@netdrive@$##Mount failed##$@netdrive@$##</a>' +
                '<a onclick="DeleteNetdriveWindowFun(\'' + type + '\',\'' + storage.name + '\')" >##$@netdrive@$##Delete##$@netdrive@$##</a>' +
                '</p></div>';
            } else if (storage.mounting) {
              var _storage_act = '<div class="volume_action"><p>' +
                // '<a id="netdriveEdit" ref-data-id='+storage.ID+'  title="##$@netdrive@$##View and Edit Volume Property##$@netdrive@$##" >##$@netdrive@$##Property##$@netdrive@$##</a>' +
                '<a ref-data-id=' + storage.ID + ' onclick="EditNetdriveWindowFun(this,\'' + storage.name + '\')" title="##$@netdrive@$##View and Edit Volume Property##$@netdrive@$##" >##$@netdrive@$##Property##$@netdrive@$##</a>' +
                '<a class="NetdriveMounting" title="##$@netdrive@$##Please refresh later##$@netdrive@$##">##$@netdrive@$##Mounting##$@netdrive@$##</a>' +
                '</p></div>';
            } else {
              var _storage_act = '<div class="volume_action"><p>' +
                // '<a id="netdriveEdit" ref-data-id='+storage.ID+'  title="##$@netdrive@$##View and Edit Volume Property##$@netdrive@$##" >##$@netdrive@$##Property##$@netdrive@$##</a>' +
                '<a ref-data-id=' + storage.ID + ' onclick="EditNetdriveWindowFun(this,\'' + storage.name + '\')" title="##$@netdrive@$##View and Edit Volume Property##$@netdrive@$##" >##$@netdrive@$##Property##$@netdrive@$##</a>' +
                '<a onclick="MountNetdriveWindowFun(\'' + storage.name + '\')" >##$@netdrive@$##Mount##$@netdrive@$##</a>' +
                '<a onclick="DeleteNetdriveWindowFun(\'' + type + '\',\'' + storage.name + '\')" >##$@netdrive@$##Delete##$@netdrive@$##</a>' +
                '</p></div>';
            }
            storage_act = _storage_act
            if (type == 'SAMBA') {
              storage_html += '<dl><samp class="samp_volume_smb"></samp>' + storage_head + storage_act + '</dl>';
            } else if (type == 'FTP') {
              storage_html += '<dl><samp class="samp_volume_ftp"></samp>' + storage_head + storage_act + '</dl>';
            } else if (type == 'WEBDAV') {
              storage_html += '<dl><samp class="samp_volume_webdav"></samp>' + storage_head + storage_act + '</dl>';
            } else if (type == 'ALIYUN_OSS') {
              storage_html += '<dl><samp class="samp_volume_aliyun"></samp>' + storage_head + storage_act + '</dl>';
            } else if (type == 'AZUREBLOB') {
              storage_html += '<dl><samp class="samp_volume_azureblob"></samp>' + storage_head + storage_act + '</dl>';
            } else if (type == 'TENCENT_COS') {
              storage_html += '<dl><samp class="samp_volume_tencent"></samp>' + storage_head + storage_act + '</dl>';
            } else if (type == 'CT_OOS') {
              storage_html += '<dl><samp class="samp_volume_ctoos"></samp>' + storage_head + storage_act + '</dl>';
            } else if (type == 'S3') {
              storage_html += '<dl><samp class="samp_volume_s3"></samp>' + storage_head + storage_act + '</dl>';
            } else if (type == "NFS") {
              storage_html += '<dl><samp class="samp_volume_nfs"></samp>' + storage_head + storage_act + '</dl>';
            } else if (type == "YANDEX") {
              storage_html += '<dl><samp class="samp_volume_yandex"></samp>' + storage_head + storage_act + '</dl>';
            } else if (type == "ONEDRIVE") {
              storage_html += '<dl><samp class="samp_volume_onedrive"></samp>' + storage_head + storage_act + '</dl>';
            } else if (type == "DROPBOX") {
              storage_html += '<dl><samp class="samp_volume_dropbox"></samp>' + storage_head + storage_act + '</dl>';
            } else if (type == "BOX") {
              storage_html += '<dl><samp class="samp_volume_box"></samp>' + storage_head + storage_act + '</dl>';
            } else if (type == "AMAZON_DRIVE") {
              storage_html += '<dl><samp class="samp_volume_amazon_drive"></samp>' + storage_head + storage_act + '</dl>';
            } else if (type == "GOOGLE_DRIVE") {
              storage_html += '<dl><samp class="samp_volume_google_drive"></samp>' + storage_head + storage_act + '</dl>';
            }
          }
          if (storage_html) {
            // var storage_content = netdrive_top + '<dd id="netdrive_'+type+'_'+storage.name+'" style="display:' +(is_open?"block":"none")+'"><div class="content"><ul><li>'+
            var storage_content = netdrive_top + '<dd id="netdrive_dd' + type + '" style="display:' + (is_open ? "block" : "none") + '"><div class="content"><ul><li>' +
              storage_html +
              '</li></ul></div></dd>';
            jQuery('#netdrive_list').append(storage_content);
          }
          // is_open = false;
        }
      }

      if (netdrive_raw) {
        var netdrive_top = '<dt class="netdrive_open">' +
          '<div class="title"><span style="margin-right:5px;">' + '##$@netdrive@$##No Net Drives##$@netdrive@$##' + '</span></div>' +
          '</dt>';
        var netdrive_content = '<dd><div class="content"><ul><li>' +
          '</li></ul></div></dd>';
        jQuery('#netdrive_list').append(netdrive_top + netdrive_content);

      }
      netdriveTranslator('netdrive_manager_page');
      hideWaiting();
      jQuery('#netdrive_manager_waiting_content').attr("style", "display: none");
      jQuery('#netdrive_manager_waiting_logo').attr("style", "display: none");
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
      hideWaiting();
    }
  });
}

function isValidIPv6(address) {
  const ipv6Regex = /^\[((?:[A-Fa-f0-9]{1,4}:)*[A-Fa-f0-9]*::?(?:[A-Fa-f0-9]{1,4}:)*[A-Fa-f0-9]*?)\](?::([0-9]{1,5}))?$/;
  return ipv6Regex.test(address);
}

function isValidIPv4(address) {
  const ipv4Regex = /^(?:(?:25[0-4]|2[0-4][0-9]|1[0-9]{2}|[1-9]?[0-9])\.){3}(?:25[0-4]|2[0-4][0-9]|1[0-9]{2}|[1-9]?[0-9])(?::([0-9]{1,5}))?$/;
  return ipv4Regex.test(address);
}

function isValidDomain(address) {
  const domainRegex = /^(?:[a-zA-Z0-9\-]+\.)+[a-zA-Z]{2,}(?::([0-9]{1,5}))?$/;
  return domainRegex.test(address);
}

// 功能函数，缩略太长的字符串
function trunc(str, len) {
  if (str == null)
    return '';
  var str_length = 0;
  var str_len = 0;
  str_cut = new String();
  str_len = str.length;
  for (var i = 0; i < str_len; i++) {
    a = str.charAt(i);
    str_length++;
    if (escape(a).length > 4) {
      str_length++;
    }
    str_cut = str_cut.concat(a);
    if (str_length > len) {
      str_cut = str_cut.concat("...");
      return str_cut;
    }
  }
  if (str_length <= len) {
    return str;
  }
}

//拼合存储源列表
function combineStorage(storage) {
  var arr = [];
  for (var key in storage) {
    if (key != 'types') {
      var arrTemp = storage[key];
      for (var i = 0, len = arrTemp.length; i < len; ++i) {
        arrTemp[i].type = key;
      }

      arr = arr.concat(arrTemp);
    }
  }
  return arr;
}

//存储源名称已经存在
function storageNameIsExisted() {
  var _name = getTrimValue('#netdrive_ipt_storage_name');
  var _datas = window.netdrive.storagesOriginal;
  for (var i = 0, len = _datas.length; i < len; ++i) {
    if (_datas[i].name === _name) {
      return true;
    }
  }
  return false;
}

function showWaiting() {
  jQuery('#netdrive_manager_waiting_content').show();
  jQuery('#netdrive_manager_waiting_logo').show();
}

// 挂载卷
function doMountVolume(name) {
  showWaiting();
  var _data = JSON.stringify({
    cmd: "netdrive_storage",
    token: UToken,
    params: {
      action: "mount",
      name: name
    }
  });
  jQuery.ajax({
    url: "/apps/netdrive/includes/index.php",
    type: "POST",
    async: true,
    data: _data,
    timeout: 30000,
    dataType: 'json',
    success: function(data) {
      if (data && parseInt(data.err) === 0) {
        // refreshData();
        // getVGsInfo()
      } else {
        hideWaiting();
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      hideWaiting();
    }
  });

}

// 卸载卷
function doUnMountVolume(name) {
  showWaiting();
  var _data = JSON.stringify({
    cmd: "netdrive_storage",
    token: UToken,
    params: {
      action: "unmount",
      name: name
    }
  });
  jQuery.ajax({
    url: "/apps/netdrive/includes/index.php",
    type: "POST",
    async: true,
    data: _data,
    timeout: 30000,
    dataType: 'json',
    success: function(data) {
      // console.log(data);
      if (data && parseInt(data.err) === 0) {
        // refreshData();
        // getVGsInfo()
      } else {
        hideWaiting();
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      hideWaiting();
    }
  });

}

// 删除卷
function doDeleteVolume(type, name) {
  showWaiting();
  var _data = JSON.stringify({
    cmd: "netdrive_storage",
    token: UToken,
    params: {
      action: "delete",
      type: type,
      name: name
    }
  });
  // console.log(_data);
  jQuery.ajax({
    url: "/apps/netdrive/includes/index.php",
    type: "POST",
    async: true,
    data: _data,
    timeout: 30000,
    dataType: 'json',
    success: function(data) {
      // console.log(data);
      if (data && parseInt(data.err) === 0) {
        refreshData();
        // getVGsInfo()
      } else {
        hideWaiting();
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      hideWaiting();
    }
  });

}

(function() {



})();
